unit InterceptAPI;

interface
uses windows;

function SetFunctionHook(lpModuleName, lpProcName: PChar;
                  NewProc: pointer; var OldProc: pointer): boolean;
                  function UnhookCode(OldProc: pointer): boolean;
procedure GenerateInstructionsSizeArray; assembler;
Procedure CalculateInstructionSize; assembler;
implementation
uses logging;

var hashbuf:array[1..$804] of byte;
procedure CalculateInstructionSize; assembler;
asm
                pushad
               mov     esi, [esp+24h]
                mov     ecx, [esp+28h]
                xor     edx, edx
                xor     eax, eax

@@loc_41C7FC:
                and     dl, 0F7h
                mov     al, [ecx]
                inc     ecx
                or      edx, [esi+eax*4]
                test    dl, 8
                jnz     @@loc_41C7FC
                cmp     al, 0F6h
                jz      @@f6f7
                cmp     al, 0F7h
                jz      @@f6f7
                cmp     al, 0CDh
                jz      @@_loc_cd
                cmp     al, 0Fh
                jz      @@_0f

@@loc_41C81B:
                test    dh, 80h
                jnz     @@loc_41C872

@@loc_41C820:
                test    dh, 40h
                jnz     @@loc_41C898

@@loc_41C825:
                test    dl, 20h
                jnz     @@loc_41C87E

@@loc_41C82A:
                test    dh, 20h
                jnz     @@loc_41C88B

@@loc_41C82F:
                mov     eax, ecx
                sub     eax, [esp+28h]
                and     edx, 707h
                add     al, dl
                add     al, dh

@@loc_41C83F:
                mov     [esp+1ch], eax
                popad
                retn
@@f6f7:
                or      dh, 40h
                test    byte ptr [ecx], 38h
                jnz     @@loc_41C81B
                or      dh, 80h
                jmp     @@loc_41C81B
@@_loc_cd:
                or      dh, 1
                cmp     byte ptr [ecx], 20h
                jnz     @@loc_41C81B
                or      dh, 4
                jmp     @@loc_41C81B
@@_0f:
                mov     al, [ecx]
                inc     ecx
                or      edx, [esi+eax*4+400h]
                cmp     edx, 0FFFFFFFFh
                jnz     @@loc_41C81B
                mov     eax, edx
                jmp     @@loc_41C83F
@@loc_41C872:
                xor     dh, 20h
                test    al, 1
                jnz     @@loc_41C820
                xor     dh, 21h
                jmp     @@loc_41C820

@@loc_41C87E:
                xor     dl, 2
                test    dl, 10h
                jnz     @@loc_41C82A
                xor     dl, 6
                jmp     @@loc_41C82A
@@loc_41C88B:
                xor     dh, 2
                test    dh, 10h
                jnz     @@loc_41C82F
                xor     dh, 6
                jmp     @@loc_41C82F

@@loc_41C898:
                mov     al, [ecx]
                inc     ecx
                mov     ah, al
                and     ax, 0C007h
                cmp     ah, 0C0h
                jz      @@loc_41C825
                test    dl, 10h
                jnz     @@loc_41C8DE
                cmp     al, 4
                jnz     @@loc_41C8BA
                mov     al, [ecx]
                inc     ecx
                and     al, 7

@@loc_41C8BA:
                cmp     ah, 40h
                jz      @@loc_41C8D6
                cmp     ah, 80h
                jz      @@loc_41C8CE
                cmp     ax, 5
                jnz     @@loc_41C825

@@loc_41C8CE:
                or      dl, 4
                jmp     @@loc_41C825

@@loc_41C8D6:
                or      dl, 1
                jmp     @@loc_41C825
@@loc_41C8DE:
                cmp     ax, 6
                jz      @@loc_41C8F2
                cmp     ah, 40h
                jz      @@loc_41C8D6
                cmp     ah, 80h
                jnz     @@loc_41C825

@@loc_41C8F2:
                or      dl, 2
                jmp     @@loc_41C825
                retn
end;
function SaveOldFunction(Proc: pointer; Old: pointer): dword;
var
  SaveSize, Size: dword;
  Next: pointer;
begin
  SaveSize := 0;
  Next := Proc;
  //   ,    
  while SaveSize < 5 do
  begin
asm
push eax
push next
push offset hashbuf
call CalculateInstructionSize
add esp, 8
mov size, eax
pop eax
end;
    Next := pointer(dword(Next) + Size);
    Inc(SaveSize, Size);
  end;
  CopyMemory(Old, Proc, SaveSize);
  //       
  byte(pointer(dword(Old) + SaveSize)^) := $e9;
  dword(pointer(dword(Old) + SaveSize + 1)^) := dword(Next) - dword(Old) - SaveSize - 5;
  Result := SaveSize;
end;
function UnhookCode(OldProc: pointer): boolean;
var
  OldProtect: dword;
  Proc: pointer;
  SaveSize: dword;
begin
  Result := True;
  try
    Proc := pointer(dword(pointer(dword(OldProc) - 5)^));
//    proc:=pointer(pointer(dword(OldProc) -5)^);
    SaveSize := byte(pointer(dword(OldProc) - 1)^);
    VirtualProtect(Proc, SaveSize, PAGE_EXECUTE_READWRITE, OldProtect);
    CopyMemory(Proc, OldProc, SaveSize);
    VirtualProtect(Proc, SaveSize, OldProtect, OldProtect);
    FreeMem(pointer(dword(OldProc) - 5));
  except
    Result := False;
  end;
end;

function HookCode(TargetProc, NewProc: pointer; var OldProc: pointer): boolean;
var
  Address: dword;
  OldProtect: dword;
  OldFunction: pointer;
  Proc: pointer;
begin
  Result := False;
  try
    Proc := TargetProc;
    //   (jmp near)    
    Address := dword(NewProc) - dword(Proc) - 5;
    VirtualProtect(Proc, 5, PAGE_EXECUTE_READWRITE, OldProtect);
    //   true 
    GetMem(OldFunction, 255);
    //  4  
    dword(OldFunction^) := dword(Proc);
    byte(pointer(dword(OldFunction) + 4)^) := SaveOldFunction(Proc, pointer(dword(OldFunction) + 5));
    //byte(pointer(dword(OldFunction) + 4)^) -   
    byte(Proc^) := $e9; // 
    dword(pointer(dword(Proc) + 1)^) := Address;
    VirtualProtect(Proc, 5, OldProtect, OldProtect);
    OldProc := pointer(dword(OldFunction) + 5);
  except
    Exit;
  end;
  Result := True;
end;

function SetFunctionHook;
var
 hModule: dword;
 fnAdr: pointer;
begin
 Result := false;
 hModule := GetModuleHandle(lpModuleName);
 if hModule = 0 then hModule := LoadLibrary(lpModuleName);
 if hModule = 0 then Exit;
 fnAdr := GetProcAddress(hModule, lpProcName);
 if fnAdr = nil then Exit;
 Result := HookCode(fnAdr, NewProc, OldProc);
end;

procedure generatesome1; assembler;
asm
                or      ebx, ebx
 jnz     @@loc_41C74A
                pop     ebp
                pop     esi
                pop     edx
                push    esi
                push    ebp
                mov     bl, 20h

@@loc_41C74A:
                dec     ebx
                shr     edx, 1
                retn
end;

procedure generatesome2; assembler;
asm
                call    generatesome1
                jnb     @@loc_41C7D4
                call    generatesome1
                jnb     @@loc_41C75F
                mov     ah, 40h
                retn
@@loc_41C75F:
                call    generatesome1
                jb      @@loc_41C7BD
                call    generatesome1
                jnb     @@loc_41C7BA
                call    generatesome1
                jnb     @@loc_41C7B7
                call    generatesome1
                jb      @@loc_41C7A0
                call    generatesome1
                jnb     @@loc_41C785
                mov     al, 20h
                retn
@@loc_41C785:
                call    generatesome1
                jnb     @@loc_41C791
                mov     ax, 2002h
                retn
@@loc_41C791:
                call    generatesome1
                jnb     @@loc_41C79D
                mov     ax, 1008h
                retn
@@loc_41C79D:
                mov     ah, 3
                retn
@@loc_41C7A0:
                call    generatesome1
                jnb     @@loc_41C7AA
                mov     ah, 60h
                retn
@@loc_41C7AA:
                call    generatesome1
                jnb     @@loc_41C7B4
                mov     al, 18h
                retn
@@loc_41C7B4:
                mov     ah, 2
                retn
@@loc_41C7B7:
                mov     ah, 80h
                retn
@@loc_41C7BA:
                mov     ah, 1
                retn
@@loc_41C7BD:
                call    generatesome1
                jnb     @@loc_41C7D1
                call    generatesome1
                jnb     @@loc_41C7CE
                mov     al, 8
                retn
@@loc_41C7CE:
                mov     ah, 41h
                retn
@@loc_41C7D1:
                mov     ah, 20h
                retn
@@loc_41C7D4:
                call    generatesome1
                adc     al, 0
                dec     eax
                retn
end;

procedure GenerateInstructionsSizeArray; assembler;
asm
                pushad
lea edi, hashbuf
                cld
                xor     eax, eax
                push    eax
                push    eax
                push    eax
                push    2AAA800h
                push    3FFF687Fh
                push    0FFE6DEA0h
                push    0DBD5FFFFh
                push    0FFFEAAAAh
                push    0AAAAAAAAh
                push    0AAAA0000h
                push    eax
                push    eax
                push    eax
                push    eax
                push    eax
                push    eax
                push    154h
                push    41FFF555h
                push    55DEDDAAh
                push    19955111h
                push    11111FFFh
                push    0FA11FFAAh
                push    8E60CF96h
                push    0FC72D6AAh
                push    0AAAAAA88h
                push    888888D5h
                push    528D559Bh
                push    366CD553h
                push    355555FFh
                push    0FFFED6F9h
                push    68888888h
                push    88888888h
                push    8D5347CAh
                push    0DCC67BDFh
                push    0AAAAAAAAh
                push    0AAAAAAAAh
                push    0ABA94FFDh
                push    0D4A7FEEAh
                push    53FF7529h
                push    0FFA4A7FEh
                push    929FFA4Ah
                push    7FE929FFh
                mov     ecx, 200h
                xor     ebx, ebx
    @@loc_41C733:
                xor     eax, eax
                call    generatesome2
                stosd
                loop    @@loc_41C733
                popad
                retn
end;

end.
