library GDIHook;

uses
{$ifdef debug}
  sysutils,
{$endif}
  windows,
  logging,
storage,
  HookedFunctions;

procedure DLLEntryPoint(Reason: Integer);
var temppath:PWideChar;
 begin
case Reason of
DLL_PROCESS_ATTACH: begin
try
getmem(temppath, max_path*2+2);
GetTempPathW(max_path, temppath);
startlog(widechartostring(temppath) + 'gdihook.log');
freemem(temppath, max_path *2 +2);
if not InitStorage then begin
exitcode:=$ff;
log('Init storage failed!');
exit;
end;
ClearStorage;
if not HookFunctions then begin
log('HookFunctions failed');
exitcode:=$ff;
end;
     except
log('Unhandled exception while initializing');
Exitcode := $ff;
end;
end;
DLL_PROCESS_DETACH: begin
UnHookFunctions;
CloseStorage;
end;
end;
end;

begin
DLLProc := @DLLEntryPoint;
                                  DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
